'use strict';

let createToken = (() => {
  var _ref = _asyncToGenerator(function* ({
    sub = null,
    expiresIn = '12h',
    clientId = process.env.CLIENT_ID,
    clientSecret = process.env.CLIENT_SECRET
  }) {
    let payload = {
      sub: _key('sess', 16)
    };

    if (sub) {
      payload.sub = sub;
    }

    const options = {
      audience: clientId,
      expiresIn: expiresIn
    };

    return new Promise(function (resolve, reject) {
      jwt.sign(payload, clientSecret, options, function (err, token) {
        if (err) {
          reject(err);
        }
        resolve({ token, payload });
      });
    });
  });

  return function createToken(_x) {
    return _ref.apply(this, arguments);
  };
})();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const _key = require('default-key');
const jwt = require('jsonwebtoken');

module.exports = createToken;