'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

const moment = require('moment');
const mapAttributes = require('./mapAttributes');
const db = require('./dynamo');

function update(TableName, { input }) {
  var { id, __typename } = input,
      rest = _objectWithoutProperties(input, ['id', '__typename']);
  var data = _extends({}, rest, { updatedAt: moment().format() });
  const exp = Object.keys(data).map(key => `#${key} = :${key}`).join(', ');
  const params = _extends({
    TableName,
    Key: { id }
  }, mapAttributes(data), {
    UpdateExpression: `SET ${exp}`,
    ReturnValues: 'ALL_NEW'
  });
  return db.updateItem(params);
}

module.exports = update;