const moment = require('moment')
const mapAttributes = require('./mapAttributes')
const db = require('./dynamo')

function update(TableName, { input }) {
  var { id, __typename, ...rest } = input;
  var data = { ...rest, updatedAt: moment().format() }
  const exp = Object.keys(data).map(key => `#${key} = :${key}`).join(', ')
  const params = {
    TableName,
    Key: { id },
    ...mapAttributes(data),
    UpdateExpression: `SET ${exp}`,
    ReturnValues: 'ALL_NEW',
  }
  return db.updateItem(params)
}

module.exports = update